package com.cogitarecomputing.dualtime;
import flash.geom.Point;
import flash.display.Sprite;
import flash.display.Bitmap;
import flash.Lib;
import openfl.Assets;

/**
 * ...
 * @author 
 */
class Hero extends Sprite
{
	private var mv:Point;
	public static var oldPos:Array<Point>;
	private var follower:Bool;
	private var creationTime:Int;
	//public var power:Float;
	private var shadow:Bitmap;
	
	public function Reset():Void
	{
		mv.x = x = 320;
		mv.y = y = 240;
		creationTime = Lib.getTimer();
		
		if (!follower)
		{
			oldPos = new Array<Point>();
		}
	}
	
	public function SetMV(p:Point):Void
	{
			mv = p.clone();
	}
	
	public function Update():Void
	{		
		shadow.x = (30 * ((x - 320) / 320)) - (shadow.width/2);
		shadow.y = (30 * ((y - 240) / 240)) - (shadow.height/2);
		
		if (follower)
		{
			var ds:Int = (Lib.getTimer() - creationTime);
			if (ds > 10000)
			{
				visible = true;
				if (oldPos.length > 0)
				{
					var p:Point = oldPos.shift();
					x = p.x;
					y = p.y;
				}
			}
		}
		else
		{
			var dx:Float = mv.x - x;
			var dy:Float = mv.y - y;
			dx = x+(dx / 10);
			dy = y+(dy / 10);
			if (Main.arenaCollision.getPixel(Math.round(dx), Math.round(dy)) == 0)
			{
				x = dx;
				y = dy;
			}
			else
			{
				if (dx > dy)
				{
					if (Main.arenaCollision.getPixel(Math.round(dx), Math.round(y)) == 0)
					{
						x = dx;
					}
					else if (Main.arenaCollision.getPixel(Math.round(x), Math.round(dy)) == 0)
					{
						y = dy;
					}
					
				}
				else
				{
					if (Main.arenaCollision.getPixel(Math.round(x), Math.round(dy)) == 0)
					{
						y = dy;
					}
					else if (Main.arenaCollision.getPixel(Math.round(dx), Math.round(y)) == 0)
					{
						x = dx;
					}
				}
				
			}
			oldPos.push(new Point(x, y));
		}
	}
	
	public function new(p:Point, follow:Bool) 
	{
		super();
		creationTime = Lib.getTimer();
		follower = follow;
		if (follow)
		{
			visible = false;
			alpha = 0.7;
		}
		else
		{
			visible = true;
			oldPos = new Array<Point>();
		}
		x = p.x;
		y = p.y;
		mv = new Point(x, y);
		shadow = new Bitmap(Assets.getBitmapData("img/ashipshadow.png"));
		shadow.alpha = 0.7;
		addChild(shadow);
		var b:Bitmap = new Bitmap(Assets.getBitmapData("img/aship2.png"));
		b.x = -b.width / 2;
		b.y = -b.height / 2;
		addChild(b);
	}
	
}