package com.cogitarecomputing.dualtime;
import flash.geom.Point;
import flash.display.Sprite;
import flash.display.Bitmap;
import flash.display.BitmapData;
import openfl.Assets;

/**
 * ...
 * @author 
 */
class Enemy extends Sprite
{
	private var hero:Hero;
	public var enemyType:Int;
	
	public function Update():Void
	{
		var dx:Float = hero.x - x;
		var dy:Float = hero.y - y;
		
		
		switch(enemyType)
		{
			case 0:
				x += dx * 0.05;
				y += dy * 0.05;
			case 1:
				var d:Float = 1 / Math.sqrt(dx * dx + dy * dy);
				 x += dx * d;
				 y += dy * d;
			case 2:
				x += dx * 0.04;
				y += dy * 0.04;
			default:
		}
		
	}
	
	public function new(p:Point, h:Hero, e:Int) 
	{
		super();
		enemyType = e;
		x = p.x;
		y = p.y;
		hero = h;
		visible = true;
		var bd:BitmapData = null;
		if (enemyType == 0)
		{
			bd = Assets.getBitmapData("img/enemy.png");
		}
		else if (enemyType == 1)
		{
			bd = Assets.getBitmapData("img/enemy2.png");
		}
		else if (enemyType == 2)
		{
			bd = Assets.getBitmapData("img/enemy3.png");
		}
			
		var b:Bitmap = new Bitmap(bd);
		b.x = -b.width / 2;
		b.y = -b.height / 2;
		addChild(b);
	}
	
}